unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, Menus, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Edit1: TEdit;
    Button1: TButton;
    StringGrid1: TStringGrid;
    Button2: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure Button2Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
procedure stringgridFuerVerknuepfungstafel(sg: TStringgrid; n:integer);
  var k:integer;
begin
  sg.ColCount := n+1;
  sg.RowCount := n+1;
  sg.FixedRows := 1;
  sg.FixedCols := 1;
  sg.cells[0,0] := '*'; //Verknpfungstabelle fr '*'
  for k := 0 to n do Begin
    sg.ColWidths[k] := 20;
    sg.RowHeights[k] := 20;
  End;
  sg.Align := alclient;
end;

procedure instringrid(sg: Tstringgrid; i,j,inhalt:integer);
begin
 sg.Cells[j,i] := FloatToStr(inhalt);
 if inhalt = 0 then sg.Objects[i,j]
end;



procedure TForm1.Button1Click(Sender: TObject);
  var n,i,j:integer;
begin
  memo1.Hide;
  stringgrid1.Show;
  n := strToInt(edit1.text);
  stringgridFuerVerknuepfungstafel(stringgrid1,n-1);
  //1. Spalte
  for i := 1 to n - 1 do instringrid(stringgrid1,i,0,i);
 //1. Reihe
  for j := 1 to n - 1 do instringrid(stringgrid1,0,j,j);
  //Verknpfungstafel
  for i := 1 to n - 1 do for j := 1 to n - 1 do
     instringrid(stringgrid1,i,j,i*j mod n);
end;

procedure TForm1.StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
                                     Rect: TRect; State: TGridDrawState);
begin
 with sender as Tstringgrid do
   if cells[ACol,ARow]='0' then Begin
     StringGrid1.Canvas.Font.Color := clred;
     //StringGrid1.Canvas.Brush.Color := clblue;
     StringGrid1.canvas.fillRect(Rect);
    StringGrid1.canvas.TextOut(Rect.Left,Rect.Top,StringGrid1.Cells[ACol,ARow]);
 End;
end;

function invers(x,n:integer):string;
  var j: integer;
begin
  for j := 1 to n - 1 do
    if x*j mod n = 1 then Begin
      result := intToStr(j);
      exit;
    End;
  result := '-'; //Kein Inverses
end;



procedure TForm1.Button2Click(Sender: TObject);
  var i,j: integer;
      s:string;
begin
  stringgrid1.Hide;
  with memo1 do Begin
    show;
    Align := alClient;
    Text := '<table border="1">';
    lines.add('Multiplikationstabelle fr Z modulo ' + IntToStr(stringgrid1.Rowcount));
    for i := 0 to stringgrid1.Rowcount - 1 do Begin
      s:='  <tr>';
      for j := 0 to stringgrid1.Colcount - 1  do Begin
        if (i=0) or (j=0) then
          s := s + '<td bgcolor="silver">'+ stringgrid1.cells[j,i] + '</td>'
           else if stringgrid1.cells[j,i] = '0' then
             s := s + '<td><font color="red">'+ stringgrid1.cells[j,i] + '</font></td>' else
               s := s + '<td>'+ stringgrid1.cells[j,i] + '</td>';
      End;
      s := s + '</tr>';
      lines.Add(s);
    End;
    lines.add('</table>');
    //Noch die Inversen
    lines.add(#13#10'<br> <br>'#13#10);
    lines.add('<table border="1">');
    s := '  <tr> <td bgcolor="silver">x</td>';
    for j := 1 to stringgrid1.Rowcount - 1 do s := s + '<td>' + intToStr(j) + '</td>';
    lines.Add(s+'</tr>');
    s := '  <tr> <td bgcolor="silver">Inverses</td>';
    for j := 1 to stringgrid1.Rowcount - 1 do
      s := s + '<td>' + invers(j,stringgrid1.Colcount) + '</td>';
    lines.Add(s+'</tr>');
    lines.add('</table>');
  End;
end;

end.
